//Corregir las proporciones de la figura representada: no se ve toda 
//Refresco de pantalla solo en las lineas necesarias
//Ver como hacerlo en Frame, color y color de pagina

//Como A77b pero el primer tramo de la seal B/N es distinto del de Color
//De momento parece la definitiva 
//Problemas con imagenes anchas

import java.applet.*;
import java.awt.*;
import java.awt.image.*;
import java.net.URL;
import java.net.MalformedURLException;


public class Webscopio extends java.applet.Applet {

	Representa  sitio;
       	Grafica grafica;
       	Image art;
       	Scrollbar barra;
       	Button boton1, boton2, boton3, boton4, boton5, boton6;
       	Label titulo;
       	int posicion;
       	int ancho_art, alto_art;
       	TextField fichero;
       	Panel superior, inferior, centro;
      
       	Font letra = new Font("Dialog", Font.BOLD|Font.ITALIC, 50);
       	MediaTracker tracker = new MediaTracker(this);

       	public void init() {
        	art = getImage(getDocumentBase(), getParameter("img"));
          	tracker.addImage(art, 0);
          	setLayout(new GridLayout(2, 1, 2, 5));
          	try {
                	tracker.waitForAll();
          	} catch (Exception e) {}
	
	//Fijar el color del fondo. Antes:(0xF5FFEF)
	Color fondo = new Color(0xE0E0E0);
 
	setBackground(fondo);
                        
      	//La barra de desplazamiento
       	int happ = Integer.parseInt(getParameter("height"));

       	barra = new Scrollbar(Scrollbar.VERTICAL, 0, 20, 0, happ/2  -  3);
        
      	//El titulo del applet
       	titulo = new Label("Webscopio");
       	titulo.setFont(letra); 
     
	//El nombre del applet y la grafica
	superior = new Panel();
        superior.setLayout(new BorderLayout());
        grafica = new Grafica(this, art, posicion);
        sitio = new Representa(art, posicion);
        superior.add("North", titulo);
 	superior.add("Center", grafica);
         
        //EL area de texto para el nombre del fichero
        fichero = new TextField(getParameter("img"));
          
        //El panel con cuatro botones y el nombre del fichero
        Panel botones = new Panel();
        botones.setLayout(new  GridLayout(6, 1, 2, 1));
        boton1 = new Button("luminancia");       
        boton2 = new Button("RGB");
        boton3 = new Button("TV B/N");
	boton4 = new Button("TV color");
	boton5 = new Button("croma");	
        //boton6 = new Button("magnificador");
        botones.add(boton1);
        botones.add(boton2);
	botones.add(boton3);
 	botones.add(boton4);
	botones.add(boton5);
	//botones.add(boton6);
        botones.add(fichero);
      
        //De momento este boton no hace nada
	//boton6.disable();

        //Engloba los botones y la barra de scroll
        centro = new Panel();
        centro.setLayout(new BorderLayout());
        centro.add("East", barra);
        centro.add("Center", sitio);

        //La parte inferior  
     	inferior = new Panel();
        inferior.setLayout(new BorderLayout());
        inferior.add("East", botones);
        inferior.add("Center", centro);
         
       	add(superior);       
	add(inferior);
	try {
        	showStatus("Webscopio Applet. Copyright  1997 Carlos F. Baladron");
    	} catch (Exception e) {}

       	}

	void update(String nombre) {

		//SOLO PARA DEPURACION
		//System.out.println("art: " + nombre);

                tracker.addImage(art, 0);
              	try {
                     tracker.waitForAll();
              	} catch (Exception e) {}
              	grafica = new Grafica(this, art, posicion);
         	sitio = new Representa(art, posicion);		
                centro.add("Center", sitio);
                inferior.add("Center", centro);
                superior.add("Center", grafica);
                add(superior);
                add(inferior);
		validate();                
	}					
	

       public boolean handleEvent(Event evt) {
          	if (evt.target == barra) {
            		posicion = ((Integer)evt.arg).intValue(); 
            		//System.out.println("posicion:" + posicion);          
            		sitio.actualiza(posicion);
            		grafica.actualiza(posicion);
	    		return true; 
         	}   
          

       		//Representar la luminancia
          	else if (evt.target == boton1) {
               		grafica.modo = 1;
               		//System.out.println("posicion:" + posicion);
 	       		grafica.actualiza(posicion);               
              		 return true;
         	}
          
       		//Representar los canales RGB
          	else if (evt.target == boton2) {
               		grafica.modo = 2;
               		grafica.actualiza(posicion);
               		//System.out.println("posicion:" + posicion);
               		return true;
           	}

        	//Representar la seal de TV en B/N
          	else if (evt.target == boton3) {
              		grafica.modo = 3;     
 	      		grafica.actualiza(posicion);
              		return true;
          	} 

		//Representar la seal de TV en color
          	else if (evt.target == boton4) {
              		grafica.modo = 4;     
 	      		grafica.actualiza(posicion);
              		return true;
          	} 

		//Representar la seal de croma
          	else if (evt.target == boton5) {
              		grafica.modo = 5;     
 	      		grafica.actualiza(posicion);
              		return true;
          	} 



         
          	//Actuar sobre el magnificador
	  	/*  if (evt.target == boton6) {
              		return true;
              	} */

          	else return super.handleEvent(evt);
	}

	public boolean action(Event evt, Object arg) {
		if (evt.target == fichero) {
			String nombre = fichero.getText();
              		art = getImage(getDocumentBase(), nombre);
              		update(nombre);                            		
              		}
		return true;
	}

}

 
class  Representa  extends Canvas {
  
	java.awt.Image outra;
     	int linea;

     	Representa(java.awt.Image figura, int valor) {
		
		outra = figura;    
     		linea = valor;
     	}
    
     
     	public void paint(java.awt.Graphics g) {
        	g.drawImage(outra, 0, 0, this); 
		g.setColor(Color.red);
        	g.drawLine(0, linea, outra.getWidth(this), linea);
     	}
   
  	
	//Recibe un entero que corresponde con la posicion de la barra y llama a repaint   
     	public void actualiza(int poxy) {
        	linea = poxy;
        	repaint();   
     	}
       
} 
 
class Grafica extends Canvas {
	
	Webscopio outerparent;
	Rectangle r[] = new Rectangle[6];
	
     	java.awt.Image origen;
     	int [] pixels;
     	int [] m_red;
     	int [] m_green;
     	int [] m_blue;
     	int [] m_luma;
     	int [] m_signal;
     	int [] m_color;
     	int [] m_croma;
	int [] m_coseno;
	int [] m_seno;
     	int [] m_burst;	

     	int ancho, alto;
     	int ancho_org, alto_org;
     	int linea;
     	double alto_canvas;
     	double factor, factorS, correccion;
     	int ancho_canvas;
	double front, back, sync;
	int limite1, limite2, limite3;
	double konst;
	int tam_br;
        
	int modo = 1;
	     
      	//Recibe como parametros el objeto imagen y la posicion del cursor   
  	Grafica(Webscopio target, java.awt.Image figura, int valor) {

 		linea = valor;
 		origen = figura;
 		ancho_org = origen.getWidth(this);
 		alto_org = origen.getHeight(this);

		this.outerparent = target;

		//SOLO PARA DEPURACION
     		//System.out.println("ancho org:" + ancho_org);

     	}



	public void handleSinglePixel(int x, int pixel) {
           	int red = (pixel >> 16) & 0xff;
           	int green = (pixel >> 8) & 0xff;
           	int blue = (pixel) & 0xff;          
        
     		//Los valores de los pixel corregidos y despalzados para que se representen bien
	   	m_red[x] = (int) (alto_canvas - red * factor);
	   	m_green[x] = (int) (alto_canvas - green *factor);
	   	m_blue[x] = (int) (alto_canvas - blue * factor);
     		//El valor de la luminancia de cada pixel
           	m_luma[x] = (int) (alto_canvas - (0.3*red+0.59*green+0.11*blue)*factor);
    }

	public void PixelsTV(int x, int pixel) {
		int red = (pixel >> 16) & 0xff;
		int green = (pixel >> 8) & 0xff;
		int blue = (pixel) & 0xff; 
		double luma =  (0.3*red+0.59*green+0.11*blue);
		//El valor de la seal de TV B/N           
		m_signal[x] = (int) (luma*factorS + correccion);
		//El valor de laseal de TV color
					    
		m_croma[x] = (int) ((0.493*(blue-luma)*Math.cos(konst*x)) + (0.877*(red-luma)*Math.sin(konst*x)));
		m_color[x] = m_signal[x] - m_croma[x];
		//El valor de la seal de croma
		 m_croma[x] = (int) (alto_canvas -  m_croma[x]);
	}


	public void Burst() {
	//El valor del burst
	//SOLO PARA DEPURACION
	System.out.println("Entro en el metodo burst");
		for (int i = 0; i < tam_br; i+=2) {
			m_burst[i] = (int) (correccion + 0.5*correccion);
		}

		for (int i = 1; i < tam_br; i+=2) {
			m_burst[i] = (int) (correccion - 0.5*correccion);
		}


	}


	public void GetPixels(Image img, int x, int y, int w, int h) {
                m_green = new int[w];
                m_red = new int[w];
                m_blue = new int[w];
                m_luma = new int[w];
                m_signal = new int[ancho_canvas];
		m_croma = new int[ancho_canvas];
                m_color = new int[ancho_canvas];
		m_coseno = new int[ancho_canvas];
		m_seno = new int[ancho_canvas];
		m_burst = new int[tam_br]; 

	        pixels = new int[w * h];
		PixelGrabber pg = new PixelGrabber(img, x, y, w, h, pixels, 0, w);
		try {
			pg.grabPixels();
		}  catch  (InterruptedException e)  {
			System.err.println("interrupcion en espera de pixels!");
			return;
		}
		if  ((pg.status() & ImageObserver.ABORT) !=0) {
			System.err.println("busqueda de imagen abortada o erronea");
			return;
		}

		Burst();

	        for (int i = 0; i < w; i++) {
			handleSinglePixel(i, pixels[i]);			
		}

                for (int i = 0; i < w; i++) {
	                PixelsTV(i, pixels[i]);
		}

                for (int i = w; i < limite1; i++) {
                        m_signal[i] = (int) correccion;
			m_color[i] = (int) correccion;
                }

                for (int i = limite1; i < limite2; i++) {
                        m_signal[i] = 1;
			m_color[i] = 1;
                }
 
                for (int i = limite2; i < limite2 + 10; i++) {
                        m_signal[i] = (int) correccion;
			m_color[i] = (int) correccion;
                }

		for (int i = limite2 + 10; i < limite2 + 10 + tam_br; i++) {
                        m_signal[i] = (int) correccion;
			m_color[i] = m_burst[i - (limite2 + 10)];
                }

		for (int i = limite2 + 10 + tam_br; i < limite3; i++) {
                        m_signal[i] = (int) correccion;
			m_color[i] = (int) correccion;
                }

    } 

	public void paint(Graphics g) { 

        	alto_canvas = size().height;//Hay que calcularlo en el metodo paint
        	ancho_canvas = size().width;//Hay que calcularlo en el metodo paint
       		factor = (alto_canvas / 256);
        	factorS = (alto_canvas / 256)*0.75;
        	correccion = (alto_canvas/4);        
        	front = ancho_org * 0.028846154;
        	sync = ancho_org * 0.090384615;
        	back = ancho_org * 0.11153846;
        	limite1 = ancho_org + (int) front;
        	limite2 = limite1 + (int) sync;
        	limite3 = limite2 + (int) back;
		konst =  1448.577/ancho_org;
        	tam_br = (int) (ancho_org/23.054819);

		//Define los rectangulos para el evento de raton
		r[0] = new Rectangle(0, 0, ancho_org, (int) alto_canvas);
		r[1] = new Rectangle(ancho_org, 0, (limite1 - ancho_org), (int) alto_canvas);
		r[2] = new Rectangle(limite1, 0, (limite2 - limite1), (int) alto_canvas);
		r[3] = new Rectangle(limite2, 0, 10, (int) alto_canvas);
		r[4] = new Rectangle((limite2 + 10), 0, tam_br, (int) alto_canvas);
		r[5] = new Rectangle((limite2 + 10 + tam_br), 0, (limite3- limite2 - 10 - tam_br), (int) alto_canvas);

    //SOLO PARA DEPURACION
	System.out.println("Long burst: " + tam_br);          
        //System.out.println("alto canvas:" + alto_canvas + "," + (int) alto_canvas);
        //System.out.println("ancho canvas:" + ancho_canvas + "," + (int) ancho_canvas);
        //System.out.println("factor:" + factor + "," + (int) factor);
        //System.out.println("factorS:" + factorS + "," + (int) factorS);
        //System.out.println("correccion:" + correccion + "," + (int) correccion);
        //System.out.println("back:" + back + "," + (int) back);
        //System.out.println("sync:" + sync + "," + (int) sync);
        //System.out.println("front:" + front + "," + (int) front);
        //System.out.println("limite1:" + limite1);
        //System.out.println("limite2:" + limite2);
        //System.out.println("limite3:" + limite3);
       
        GetPixels(origen, 0, linea, ancho_org, 1);                              
            switch (modo) {
 
                case 1:        //Representa Luminancia
                   setBackground(Color.white);
                   for (int x = 0 ; x < (ancho_org - 1) ; x++) {             
                       g.setColor(Color.black);//La luminancia        
                       g.drawLine(x, m_luma[x], x+1, m_luma[x+1]);
                   }
		break;
              
                case 2:       //Representa RGB
                  setBackground(Color.white);
		  for (int x = 0 ; x < (ancho_org - 1) ; x++) {
                      g.setColor(Color.red);//El canal rojo        
                      g.drawLine(x, m_red[x], x+1,  m_red[x+1]); 

                      g.setColor(Color.green);//El canal verde, un pixel abajo para grises          
                      g.drawLine(x,  m_green[x] + 2, x+1, m_green[x+1] + 2);

                      g.setColor(Color.blue);//El canal azul, dos pixel abajo para grises        
                      g.drawLine(x, m_blue[x] + 4, x+1, m_blue[x+1] + 4);
                  }
 	  	break;

                case 3:        //Representa Seal de TV B/N
                   setBackground(Color.black);
                   for (int x = 0 ; x < (limite3) ; x++) { 
                       //setBackground(Color.black);            
                       g.setColor(Color.green);//La seal de TV        
                       g.drawLine(x, m_signal[x], x+1, m_signal[x+1]);
                   }
		break;

		case 4:        //Representa Seal de TV Color
                   setBackground(Color.black);
                   for (int x = 0 ; x < (limite3) ; x++) { 
                       //setBackground(Color.black);            
                       g.setColor(Color.green);//La seal de TV        
                       g.drawLine(x, m_color[x], x+1, m_color[x+1]);
                   }
		break;


		case 5:         //Representa Croma
                   setBackground(Color.black);
                   for (int x = 0 ; x < (ancho_org-1) ; x++) { 
                       //setBackground(Color.black);            
                       g.setColor(Color.green);//La seal de TV        
                       g.drawLine(x, m_croma[x], x+1, m_croma[x+1]);
                   }
		break;

                 
           } 
    }

 	//Recibe un entero que corresponde con la posicion del cursor de la barra y llama a repaint 
	public void actualiza(int poxy) {
      	  linea = poxy;
          repaint();   
        }


	public boolean mouseDown(Event evms, int x, int y) {

		//SOLO PARA DEPURACION
		//System.out.println( "Posicion:(" + x + "," + y + ")");
		
		String LumURL = new String(this.outerparent.getParameter("LumURL"));
		String rgbURL = new String(this.outerparent.getParameter("rgbURL"));
		String bnURL = new String(this.outerparent.getParameter("bnURL"));
		String CromaURL =  new String(this.outerparent.getParameter("CromaURL"));
		String ColorURL[] = new String[6];
		for (int cont = 0; cont <=5; cont++) {
			 ColorURL[cont] =  this.outerparent.getParameter("ColorURL"+cont);
		};
				
		if (modo == 1) {
		//System.out.println("");
			try
			{
				URL enlace = new URL(LumURL);
				this.outerparent.getAppletContext().showDocument(enlace,"_parent");
			}
			catch (Exception ex)
			{
				System.out.println("No se encuentra "  +  LumURL);
			}
		}
		
		if (modo == 2) {
		//System.out.println("");
			try
			{
				URL enlace = new URL(rgbURL);
				this.outerparent.getAppletContext().showDocument(enlace,"_parent");
			}
			catch (Exception ex)
			{
				System.out.println("No se encuentra "  +  rgbURL);
			}
		}

		//La seal de TV en B/N
		if (modo == 3) {
		//System.out.println("");

			if (r[0].inside(x, y)) {
				try
				{
					URL enlace = new URL(bnURL);
					this.outerparent.getAppletContext().showDocument(enlace,"_parent");
				}
				catch (Exception ex)
				{
				System.out.println("No se encuentra "  +  bnURL);
				}
			}



			for (int cont = 1; cont <=3; cont++) {

				//SOLO PARA DEPURACION
				//if (r[cont].isEmpty()) System.out.println("Rectangulo vacio " + cont);

				if (r[cont].inside(x, y)) {
					//Rectangulo seleccionado es el cont

					//SOLO PARA DEPURACION
					//System.out.println("Rectangulo seleccionado " + cont);

					try
					{
						URL enlace = new URL(ColorURL[cont]);
						this.outerparent.getAppletContext().showDocument(enlace,"_parent");
					}
					catch (Exception ex)
					{
					System.out.println("No se encuentra "  +  ColorURL[cont]);
					}

				}		
			}

			if ((r[4].inside(x, y)) || (r[5].inside(x, y))) {
				try
				{
					URL enlace = new URL(ColorURL[3]);
					this.outerparent.getAppletContext().showDocument(enlace,"_parent");
				}
				catch (Exception ex)
				{
				System.out.println("No se encuentra "  +  ColorURL[3]);
				}
			}
			
		}
		
		if (modo == 4) {
	 		for (int cont = 0; cont <=5; cont++) {

				//SOLO PARA DEPURACION
				//if (r[cont].isEmpty()) System.out.println("Rectangulo vacio " + cont);

				if (r[cont].inside(x, y)) {
					//Rectangulo seleccionado es el cont
					System.out.println("Rectangulo seleccionado " + cont);
					try
					{
						URL enlace = new URL(ColorURL[cont]);
						this.outerparent.getAppletContext().showDocument(enlace,"_parent");
					}
					catch (Exception ex)
					{
					System.out.println("No se encuentra "  +  ColorURL[cont]);
					}

				}		
			}
		}
		
		if (modo == 5) {
		//System.out.println("");
			try
			{
				URL enlace = new URL(CromaURL);
				this.outerparent.getAppletContext().showDocument(enlace,"_parent");
			}
			catch (Exception ex)
			{
				System.out.println("No se encuentra "  +  CromaURL);
			}
		}

		return true;
	}

    
} 
    
